{-----------------------------------------------------------------------------
The contents of this file are subject to the Mozilla Public License
Version 1.1 (the "License"); you may not use this file except in compliance
with the License. You may obtain a copy of the License at
http://www.mozilla.org/MPL/MPL-1.1.html

Software distributed under the License is distributed on an "AS IS" basis,
WITHOUT WARRANTY OF ANY KIND, either expressed or implied. See the License for
the specific language governing rights and limitations under the License.

The Original Code is: main.PAS, released on 29 September 2005.

The Initial Developer of the Original Code is Alexey Nikitayev [nikitayev@rsu.ru]
All Rights Reserved.

Contributor(s):

Last Modified: 29 September 2005

You may retrieve the latest version of this file at the Project Opencomputer's home page,
located at http://opencomputer.narod.ru/

Known Issues:
  Some corrupted files are not recovering.
  About 90-95% can be processed.

Required: none
-----------------------------------------------------------------------------}
{
  ENG:
    The program saves all selected files of Word and Excel in the subfolder 
    "resaved" under unique names.
  RUS:
     -         . 
        -     
    (   - ...).
}
unit main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Mask, ComCtrls, ShellCtrls, ExtCtrls, Buttons,
  About;
  
type
  TForm1 = class(TForm)
    Memo1: TMemo;
    Panel1: TPanel;
    Button1: TButton;
    Panel2: TPanel;
    ShellTreeView1: TShellTreeView;
    ShellListView1: TShellListView;
    SpeedButton1: TSpeedButton;
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    procedure Log(const text:string);
  end;

var
  Form1: TForm1;

implementation
uses ComObj;

{$R *.dfm}

function PrepareFileName(const FileName:string):string;
var
  i:Integer;
begin
  Result:='';
  for i:=1 to Length(FileName) do
  if FileName[i] in 
    ['','(',')','0'..'9','A'..'Z','a'..'z',' ','-',
     ''..'',''..'','','','.',','] then
    result:=result+FileName[i] else result:=result+' ';
  result:=Trim(result);
end;

function GetFileSize(const FileName:string):Int64;
var
  F: TSearchRec;
  R: Integer;
begin
  Result:=0;
  R := SysUtils.FindFirst(FileName, faAnyFile, F);
  if R=0 then
    Result:=F.Size;
  SysUtils.FindClose(F);
end;

function GetPathForResaved (const OriginalFileName:string):string;
begin
  Result:=ExtractFilePath(OriginalFileName)+'resaved\';
end;

function GetNewFileNameForResaved (const OriginalFileName:string):string;
begin
  Result:=GetPathForResaved(OriginalFileName)+ExtractFileName(OriginalFileName);
end;

function GetUniqueFileName(const FileName:string):string;
var
  i:Integer;
  BeginFN, EndFN:string;
begin
  i:=2;
  Result:=FileName;
  if FileExists(FileName) then
  begin
    BeginFN:=ExtractFileName(FileName);
    BeginFN:=copy(BeginFN,1,Length(BeginFN)-Length(ExtractFileExt(BeginFN)));
    BeginFN:=ExtractFilePath(FileName)+BeginFN+'_';
    EndFN:=ExtractFileExt(FileName);
    while FileExists(BeginFN+IntToStr(i)+EndFN) do Inc(i);
    Result:=BeginFN+IntToStr(i)+EndFN;
  end;
end;

function ResaveWordDoc(const SrcFilename: string;var DestFileName:string):boolean;
var
  WordApplication: Variant;
  ActiveDocument: Variant;
  Count,i:Integer;
  Line:string;
  EmptyLine : boolean;
begin
  result:=false;
  if (SrcFilename='') then exit;
  try
    WordApplication := CreateOleObject('Word.Application'); //Word.Basic
  except
    on E:Exception do
    begin
      Exit;
    end;
  end;
  try
    ActiveDocument:=WordApplication.Documents.Open(SrcFilename, False,
      False, False, '','', False, '','',,,True,False,,True);
  except
    on E:Exception do
    begin
      WordApplication.Quit;
      Exit;
    end;
  end;
  try
    Count:=ActiveDocument.Paragraphs.Count;
    if Count=0 then
    begin
      ActiveDocument.Close;
      WordApplication.Quit;
      Exit;
    end;
  except
    on E:Exception do
    begin
      ActiveDocument.Close;
      WordApplication.Quit;
      Exit;
    end;
  end;
  EmptyLine := True;
  try
    DestFileName:=ExtractFilePath(SrcFilename)+'resaved';
    ForceDirectories(DestFileName);
//    Form1.Log(Format('Count=%d',[Count]));
    for i:=1 to Count do
    begin
      ActiveDocument.Paragraphs.Item(i).Range.Select;
      Line:=Trim(ActiveDocument.Paragraphs.Item(i).Range.Text);
      Line:=PrepareFileName(Line);
      if (Line='') then continue;
      EmptyLine := False;
      DestFileName:=GetUniqueFileName(DestFileName+'\'+Line+'.doc');
      Form1.Log(DestFileName);
      break;
    end;
  except
  end;
  if (EmptyLine) then
  begin
    ActiveDocument.Close;
    WordApplication.Quit;
    exit;
  end;
  try
    ActiveDocument.SaveAs(DestFileName,, False, '', True,
        '', False, False, False, False, False,,,,,);
  except
    on E:Exception do
    begin
    end;
  end;
  try
    ActiveDocument.Close;
  except
    on E:Exception do
    begin
    end;
  end;
  try
    WordApplication.Quit;
  except
  end;
  WordApplication:=Null;
  result:=true;
end;

function ResaveExcelDoc(const SrcFilename: string;var DestFileName:string):boolean;
var
  ExcelApplication: Variant;
  Workbook: Variant;
  Worksheet:Integer;
  Count,Row,Column:Integer;
  Line:string;
  EmptyLine : boolean;
  OLEWorksheet:Variant;
begin
  result:=false;
  if (SrcFilename='') then exit;
  try
    ExcelApplication := CreateOleObject('Excel.Application'); //Word.Basic
  except
    on E:Exception do
    begin
      Exit;
    end;
  end;
  try
    Workbook:=ExcelApplication.Workbooks.Open(SrcFileName,
      ,False,,,,,,,,False,,False,,);
  except
    on E:Exception do
    begin
      ExcelApplication.Quit;
      Exit;
    end;
  end;
  try
    Count:=Workbook.WorkSheets.Count;
    if Count=0 then
    begin
      Workbook.Close;
      ExcelApplication.Quit;
      Exit;
    end;
  except
    on E:Exception do
    begin
      Workbook.Close;
      ExcelApplication.Quit;
      Exit;
    end;
  end;
  EmptyLine := True;
  try
    DestFileName:=ExtractFilePath(SrcFilename)+'resaved';
    ForceDirectories(DestFileName);
    for Worksheet:=1 to Count do
    begin
      OLEWorksheet:=Workbook.WorkSheets[Worksheet];
      for Row:=1 to 100 do
      begin
        for Column:=1 to 100 do
        begin
          Line:=Trim(OLEWorksheet.Cells[Row,Column].Text);
          Line:=PrepareFileName(Line);
          if (Line='') then continue;
          EmptyLine := False;
          DestFileName:=GetUniqueFileName(DestFileName+'\'+Line+'.xls');
          Form1.Log(DestFileName);
          break;
        end;
        if (Line<>'') then break;
      end;
      if not EmptyLine then break;
    end;
  except
  end;
  if (EmptyLine) then
  begin
    Workbook.Close;
    ExcelApplication.Quit;
    exit;
  end;
  try
    Workbook.SaveAs(DestFileName);
  except
    on E:Exception do
    begin
    end;
  end;
  try
    Workbook.Close;
  except
    on E:Exception do
    begin
    end;
  end;
  try
    ExcelApplication.Quit;
  except
  end;
  ExcelApplication:=Null;
  result:=true;
end;

procedure TForm1.Button1Click(Sender: TObject);
var
  i:Integer;
  Filename,DestFileName:string;
begin
  if ShellListView1.SelCount=0 then exit;
  Screen.Cursor:=crHourGlass;
  Memo1.Clear;
  Memo1.SetFocus;
  Button1.Enabled:=false;
  Application.ProcessMessages;
  //ForceDirectories(ExtractFilePath(OriginalFileName)+'resaved');
  for i:=0 to ShellListView1.Items.Count-1 do
  if (ShellListView1.Items[i].Selected) then
  begin
    // Word
    if (UpperCase(ExtractFileExt(ShellListView1.Folders[i].PathName))='.DOC') then
    try
      Filename:=ShellListView1.Folders[i].PathName;
      if (not ResaveWordDoc(Filename,DestFileName)) or (GetFileSize(DestFileName)<3)
      then
      begin
        try
          DeleteFile(Filename);
          if FileExists(DestFileName) then DeleteFile(DestFileName);
          Memo1.Lines.Add(Format('%s - error, deleted',[ExtractFileName(Filename)]));
        except
          Memo1.Lines.Add(Format('%s - error, can''t deleted!',[ExtractFileName(Filename)]));
        end;
      end else
      begin
        Memo1.Lines.Add(Format('%s - ok',[ExtractFileName(Filename)]));
      end;
      Memo1.ScrollBy(0,100);
      Memo1.Invalidate;
      Application.ProcessMessages;
    except
    end;
    // Excel
    if (UpperCase(ExtractFileExt(ShellListView1.Folders[i].PathName))='.XLS') then
    try
      Filename:=ShellListView1.Folders[i].PathName;
      if (not ResaveExcelDoc(Filename,DestFileName)) or (GetFileSize(DestFileName)<3)
      then
      begin
        try
          //DeleteFile(Filename);
          //if FileExists(DestFileName) then DeleteFile(DestFileName);
          Memo1.Lines.Add(Format('%s - error, deleted',[ExtractFileName(Filename)]));
        except
          Memo1.Lines.Add(Format('%s - error, can''t deleted!',[ExtractFileName(Filename)]));
        end;
      end else
      begin
        Memo1.Lines.Add(Format('%s - ok',[ExtractFileName(Filename)]));
      end;
      Memo1.ScrollBy(0,100);
      Memo1.Invalidate;
      Application.ProcessMessages;
    except
    end;
  end;
  Screen.Cursor:=crDefault;
  ShellListView1.Refresh;
  Button1.Enabled:=True;
end;

procedure TForm1.Log(const text: string);
begin
  Memo1.Lines.Add(text);
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  DoubleBuffered:=true;
  Memo1.DoubleBuffered:=true;
end;

procedure TForm1.SpeedButton1Click(Sender: TObject);
begin
  About.AboutBox.ShowModal;
end;

end.
